cookutils annotate cook @ rev 145

Use special case for https (Thanks Godane)
author Christophe Lincoln <pankso@slitaz.org>
date Wed May 11 18:32:31 2011 +0200 (2011-05-11)
parents 112dbe0ed058
children d9c589758654
rev   line source
pankso@1 1 #!/bin/sh
pankso@1 2 #
pankso@1 3 # Cook - A tool to cook and generate SliTaz packages. Read the README
pankso@1 4 # before adding or modifing any code in cook!
pankso@1 5 #
pankso@1 6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
pankso@1 7 # Author: Christophe Lincoln <pankso@slitaz.org>
pankso@1 8 #
pankso@1 9
pankso@1 10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
pankso@1 11 [ -f "cook.conf" ] && . ./cook.conf
pankso@1 12
pankso@16 13 # Share DB and status with the Cooker.
pankso@9 14 activity="$CACHE/activity"
pankso@16 15 command="$CACHE/command"
pankso@11 16 broken="$CACHE/broken"
pankso@47 17 blocked="$CACHE/blocked"
pankso@9 18
pankso@1 19 #
pankso@1 20 # Functions
pankso@1 21 #
pankso@1 22
pankso@1 23 usage() {
pankso@1 24 cat << EOT
pankso@1 25
pankso@1 26 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command|list] [--option]
pankso@1 27
pankso@1 28 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
pankso@1 29 usage|help $(gettext "Display this short usage.")
pankso@1 30 setup $(gettext "Setup your build environment.")
pankso@9 31 test $(gettext "Test environment and cook a package.")
pankso@69 32 list-wok $(gettext "List packages in the wok.")
pankso@69 33 search $(gettext "Simple packages search function.")
paul@62 34 new $(gettext "Create a new package with a receipt".)
pankso@1 35 list $(gettext "Cook a list of packages.")
pankso@1 36 clean-wok $(gettext "Clean-up all packages files.")
paul@62 37 clean-src $(gettext "Clean-up all packages sources.")
pankso@1 38 pkglist $(gettext "Create all packages.* lists.")
pankso@1 39
pankso@1 40 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
pankso@10 41 --clean|-c Cook : $(gettext "clean the package in the wok.")
pankso@39 42 --install|-i Cook : $(gettext "cook and install the package.")
pankso@39 43 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
pankso@49 44 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
pankso@49 45 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
pankso@10 46 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
pankso@1 47
pankso@1 48 EOT
pankso@1 49 exit 0
pankso@1 50 }
pankso@1 51
paul@62 52 # Be sure we're root.
pankso@1 53 check_root() {
pankso@1 54 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
pankso@1 55 }
pankso@1 56
pankso@1 57 separator() {
pankso@1 58 echo "================================================================================"
pankso@1 59 }
pankso@1 60
pankso@1 61 status() {
pankso@1 62 echo -en "\\033[70G[ "
pankso@1 63 if [ $? = 0 ]; then
pankso@1 64 echo -en "\\033[1;32mOK"
pankso@1 65 else
pankso@1 66 echo -en "\\033[1;31mFailed"
pankso@1 67 fi
pankso@1 68 echo -e "\\033[0;39m ]"
pankso@1 69 }
pankso@1 70
pankso@13 71 # Log activities, we want first letter capitalized.
pankso@9 72 log() {
pankso@27 73 grep ^[A-Z] | \
pankso@9 74 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
pankso@9 75 }
pankso@9 76
paul@62 77 # We don't want these escapes in web interface.
pankso@1 78 clean_log() {
pankso@1 79 sed -i -e s'|\[70G\[ \[1;32m| |' \
pankso@1 80 -e s'|\[0;39m \]||' $LOGS/$pkg.log
pankso@1 81 }
pankso@1 82
pankso@23 83 # Log broken packages.
pankso@23 84 broken() {
pankso@74 85 if ! grep -q "^$pkg$" $broken; then
pankso@74 86 echo "$pkg" >> $broken
pankso@74 87 fi
pankso@23 88 }
pankso@23 89
paul@62 90 # Be sure package exists in wok.
pankso@1 91 check_pkg_in_wok() {
pankso@1 92 if [ ! -d "$WOK/$pkg" ]; then
pankso@1 93 gettext -e "\nUnable to find package in the wok:"
pankso@1 94 echo -e " $pkg\n" && exit 1
pankso@1 95 fi
pankso@1 96 }
pankso@1 97
pankso@9 98 if_empty_value() {
pankso@9 99 if [ -z "$value" ]; then
pankso@9 100 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
pankso@9 101 exit 1
pankso@9 102 fi
pankso@9 103 }
pankso@9 104
paul@62 105 # Initialize files used in $CACHE
pankso@52 106 init_db_files() {
pankso@52 107 gettext "Creating directories structure in:"; echo " $SLITAZ"
pankso@52 108 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
pankso@52 109 gettext "Creating DB files in:"; echo " $CACHE"
pankso@52 110 for f in $activity $command $broken $blocked
pankso@52 111 do
pankso@52 112 touch $f
pankso@52 113 done
pankso@52 114 }
pankso@52 115
paul@62 116 # QA: check a receipt consistency before building.
pankso@9 117 receipt_quality() {
pankso@9 118 gettext -e "QA: checking package receipt...\n"
pankso@9 119 unset online
pankso@9 120 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
pankso@9 121 online="online"
pankso@9 122 fi
pankso@9 123 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
pankso@9 124 do
pankso@9 125 unset value
pankso@44 126 value=$(grep ^$var= $receipt | cut -d \" -f 2)
pankso@9 127 case "$var" in
pankso@9 128 PACKAGE|VERSION|SHORT_DESC)
pankso@9 129 if_empty_value ;;
pankso@9 130 CATEGORY)
pankso@9 131 [ -z "$value" ] && value="empty"
pankso@9 132 valid="base-system x-window utilities network graphics \
pankso@9 133 multimedia office development system-tools security games \
pankso@9 134 misc meta non-free"
pankso@9 135 if ! echo "$valid" | grep -q -w "$value"; then
paul@62 136 gettext "QA: unknown category:"; echo -e " $value\n"
pankso@9 137 exit 1
pankso@9 138 fi ;;
pankso@9 139 WEB_SITE)
paul@62 140 # We don't check WGET_URL since if dl is needed it will fail.
paul@62 141 # Break also if we're not online. Here error is not fatal.
pankso@9 142 if_empty_value
pankso@9 143 [ -z "$online" ] || break
pankso@9 144 if ! busybox wget -s $value 2>/dev/null; then
pankso@61 145 gettext "QA: Unable to reach:"; echo -e " $value"
pankso@9 146 fi ;;
pankso@9 147 esac
pankso@9 148 done
pankso@9 149 }
pankso@9 150
pankso@9 151 # Executed before sourcing a receipt.
pankso@9 152 unset_receipt() {
pankso@9 153 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
pankso@9 154 }
pankso@9 155
paul@62 156 # Paths used in receipt and by cook itself.
pankso@1 157 set_paths() {
pankso@1 158 pkgdir=$WOK/$PACKAGE
pankso@1 159 src=$pkgdir/source/$PACKAGE-$VERSION
pankso@44 160 taz=$pkgdir/taz
pankso@44 161 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
pankso@1 162 fs=$pack/fs
pankso@1 163 stuff=$pkgdir/stuff
pankso@1 164 install=$pkgdir/install
pankso@1 165 if [ "$WANTED" ]; then
pankso@1 166 src=$WOK/$WANTED/source/$WANTED-$VERSION
pankso@1 167 install=$WOK/$WANTED/install
pankso@121 168 wanted_stuff=$WOK/$WANTED/stuff
pankso@1 169 fi
pankso@9 170 # Old way compatibility.
pankso@1 171 _pkg=$install
pankso@1 172 }
pankso@1 173
pankso@144 174 # Create source tarball when URL is a SCM.
pankso@144 175 create_tarball() {
pankso@144 176 gettext "Creating tarball: "; echo "$tarball"
pankso@144 177 tar cjf $tarball $pkgsrc || exit 1
pankso@144 178 mv $tarball $SRC && rm -rf $pkgsrc
pankso@144 179 }
pankso@144 180
pankso@145 181 # Get package source. For SCM we are in cache so clone here and create a
pankso@145 182 # tarball here.
pankso@1 183 get_source() {
pankso@115 184 pwd=$(pwd)
pankso@144 185 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
pankso@144 186 tarball=$pkgsrc.tar.bz2
pankso@9 187 case "$WGET_URL" in
pankso@145 188 http://*|ftp://*)
pankso@9 189 # Busybox Wget is better!
pankso@145 190 busybox wget -c -P $SRC $WGET_URL || \
pankso@145 191 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@145 192 https://*)
pankso@145 193 wget -c --no-check-certificate -P $SRC $WGET_URL || \
pankso@15 194 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@9 195 hg*|mercurial*)
pankso@29 196 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
pankso@9 197 url=${WGET_URL#hg|}
pankso@9 198 else
pankso@9 199 url=${WGET_URL#mercurial|}
pankso@9 200 fi
pankso@61 201 gettext -e "Getting source from Hg...\n"
pankso@61 202 echo "URL: $url"
pankso@9 203 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
pankso@15 204 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
pankso@144 205 create_tarball ;;
pankso@9 206 git*)
pankso@61 207 url=${WGET_URL#git|}
pankso@61 208 gettext -e "Getting source from Git...\n"
pankso@61 209 echo "URL: $url"
pankso@64 210 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
pankso@63 211 if [ "$BRANCH" ]; then
pankso@64 212 cd $pkgsrc && git checkout $BRANCH && cd ..
pankso@63 213 fi
pankso@144 214 create_tarball ;;
pankso@144 215 cvs*)
pankso@144 216 url=${WGET_URL#cvs|}
pankso@144 217 mod=$PACKAGE
pankso@144 218 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
pankso@144 219 gettext -e "Getting source from CVS...\n"
pankso@144 220 echo "URL: $url"
pankso@144 221 echo "CVS module: $mod"
pankso@144 222 gettext "Cloning to: "; echo "$pwd/$mod"
pankso@144 223 cvs -d:$url co $mod && mv $mod $pkgsrc
pankso@144 224 create_tarball ;;
pankso@69 225 svn*|subversion*)
pankso@9 226 echo "TODO: svn implementation in cook" && exit 1 ;;
pankso@9 227 *)
pankso@9 228 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
pankso@9 229 tee -a $LOGS/$PACKAGE.log
pankso@9 230 exit 1 ;;
pankso@9 231 esac
pankso@1 232 }
pankso@1 233
pankso@9 234 # Extract source package.
pankso@1 235 extract_source() {
pankso@1 236 gettext "Extracting:"; echo " $TARBALL"
pankso@1 237 case "$TARBALL" in
pankso@120 238 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
pankso@120 239 *.tar.bz2|*.tbz) tar xjf $SRC/$TARBALL 2>/dev/null ;;
pankso@1 240 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
pankso@42 241 *.tar) tar xf $SRC/$TARBALL ;;
pankso@42 242 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
pankso@42 243 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
pankso@42 244 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
pankso@42 245 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
pankso@1 246 esac
pankso@1 247 }
pankso@1 248
pankso@9 249 # Display cooked package summary.
pankso@1 250 summary() {
pankso@1 251 cd $WOK/$pkg
pankso@1 252 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
pankso@1 253 fs=$(du -sh taz/* | awk '{print $1}')
pankso@44 254 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
pankso@44 255 files=$(cat taz/$pkg-*/files.list | wc -l)
pankso@18 256 cookdate=$(date "+%Y-%m-%d %H:%M")
pankso@101 257 sec=$time
pankso@104 258 div=$(($time / 60))
pankso@112 259 [ "$div" != 0 ] && min="~ ${div}m"
pankso@1 260 gettext "Summary for:"; echo " $PACKAGE $VERSION"
pankso@1 261 separator
pankso@67 262 [ "$prod" ] && echo "Produced : $prod"
pankso@1 263 cat << EOT
pankso@1 264 Packed : $fs
pankso@1 265 Compressed : $size
pankso@18 266 Files : $files
pankso@102 267 Cook time : ${sec}s $min
pankso@18 268 Cook date : $cookdate
pankso@1 269 $(separator)
pankso@1 270 EOT
pankso@1 271 }
pankso@1 272
paul@62 273 # Display debugging error info.
pankso@15 274 debug_info() {
pankso@17 275 echo -e "\nDebug information"
pankso@15 276 separator
pankso@48 277 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
pankso@76 278 for error in \
pankso@77 279 ERROR "No package" "cp: can't" "can't open" "can't cd" \
pankso@76 280 "error:" "fatal error:"
pankso@34 281 do
pankso@34 282 fgrep "$error" $LOGS/$pkg.log
pankso@34 283 done
pankso@15 284 separator && echo ""
pankso@15 285 }
pankso@15 286
pankso@1 287 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
pankso@1 288 # so some packages need to copy these files with the receipt and genpkg_rules.
pankso@1 289 copy_generic_files()
pankso@1 290 {
pankso@1 291 # $LOCALE is set in cook.conf
pankso@1 292 if [ "$LOCALE" ]; then
pankso@1 293 if [ -d "$_pkg/usr/share/locale" ]; then
pankso@1 294 mkdir -p $fs/usr/share/locale
pankso@1 295 for i in $LOCALE
pankso@1 296 do
pankso@1 297 if [ -d "$_pkg/usr/share/locale/$i" ]; then
pankso@1 298 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
pankso@1 299 fi
pankso@1 300 done
pankso@1 301 fi
pankso@1 302 fi
pankso@1 303
pankso@1 304 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
pankso@1 305 if [ "$GENERIC_PIXMAPS" != "no" ]; then
pankso@1 306 if [ -d "$_pkg/usr/share/pixmaps" ]; then
pankso@1 307 mkdir -p $fs/usr/share/pixmaps
pankso@1 308 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
pankso@1 309 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 310 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
pankso@1 311 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 312 fi
pankso@1 313
pankso@1 314 # Custom or homemade PNG pixmap can be in stuff.
pankso@1 315 if [ -f "$stuff/$PACKAGE.png" ]; then
pankso@1 316 mkdir -p $fs/usr/share/pixmaps
pankso@1 317 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
pankso@1 318 fi
pankso@1 319 fi
pankso@1 320
pankso@1 321 # Desktop entry (.desktop).
pankso@1 322 if [ -d "$_pkg/usr/share/applications" ]; then
pankso@1 323 cp -a $_pkg/usr/share/applications $fs/usr/share
pankso@1 324 fi
pankso@1 325
pankso@1 326 # Homemade desktop file(s) can be in stuff.
pankso@1 327 if [ -d "$stuff/applications" ]; then
pankso@1 328 mkdir -p $fs/usr/share
pankso@1 329 cp -a $stuff/applications $fs/usr/share
pankso@1 330 fi
pankso@1 331 if [ -f "$stuff/$PACKAGE.desktop" ]; then
pankso@1 332 mkdir -p $fs/usr/share/applications
pankso@1 333 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
pankso@1 334 fi
pankso@1 335 }
pankso@1 336
pankso@67 337 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
pankso@68 338 # as removing uneeded files like in Python packages.
pankso@1 339 strip_package()
pankso@1 340 {
pankso@67 341 gettext "Executing strip on all files..."
pankso@1 342 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
pankso@1 343 do
pankso@1 344 if [ -d "$dir" ]; then
pankso@1 345 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
pankso@1 346 fi
pankso@1 347 done
pankso@1 348 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
pankso@1 349 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
pankso@1 350 status
pankso@67 351
pankso@117 352 # Remove Python .pyc and .pyo from packages.
pankso@117 353 if echo "$DEPENDS" | fgrep -q "python"; then
pankso@68 354 gettext "Removing Python compiled files..."
pankso@67 355 find $fs -type f -name "*.pyc" -delete 2>/dev/null
pankso@67 356 find $fs -type f -name "*.pyo" -delete 2>/dev/null
pankso@117 357 status
pankso@117 358 fi
pankso@117 359
pankso@117 360 # Remove Perl perllocal.pod and .packlist from packages.
pankso@117 361 if echo "$DEPENDS" | fgrep -q "perl"; then
pankso@117 362 gettext "Removing Perl compiled files..."
pankso@67 363 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
pankso@67 364 find $fs -type f -name ".packlist" -delete 2>/dev/null
pankso@67 365 status
pankso@67 366 fi
pankso@1 367 }
pankso@1 368
pankso@8 369 # Remove installed deps.
pankso@8 370 remove_deps() {
pankso@8 371 # Now remove installed build deps.
pankso@113 372 diff="$CACHE/installed.cook.diff"
pankso@113 373 if [ -s "$CACHE/installed.cook.diff" ]; then
pankso@113 374 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
pankso@113 375 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@8 376 gettext "Build dependencies to remove:"; echo " $nb"
pankso@8 377 gettext "Removing:"
pankso@8 378 for dep in $deps
pankso@8 379 do
pankso@8 380 echo -n " $dep"
pankso@8 381 yes | tazpkg remove $dep >/dev/null
pankso@8 382 done
pankso@16 383 echo -e "\n"
pankso@113 384 # Keep the last diff for debug and info.
pankso@113 385 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
pankso@1 386 fi
pankso@1 387 }
pankso@1 388
pankso@1 389 # The main cook function.
pankso@1 390 cookit() {
pankso@11 391 echo "Cook: $PACKAGE $VERSION"
pankso@9 392 separator
pankso@1 393 set_paths
pankso@9 394 [ "$QA" ] && receipt_quality
pankso@44 395 cd $pkgdir
pankso@33 396 rm -rf install taz source
pankso@1 397
pankso@1 398 # Disable -pipe if less than 512Mb free RAM.
pankso@1 399 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
pankso@1 400 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
pankso@1 401 gettext -e "Disabling -pipe compile flag: $free RAM\n"
pankso@1 402 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
pankso@47 403 CXXFLAGS="${CXXFLAGS/-pipe}" && \
pankso@47 404 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
pankso@1 405 fi
pankso@1 406 unset free
pankso@1 407
pankso@1 408 # Export flags and path to be used by make
pankso@44 409 DESTDIR=$pkgdir/install
pankso@1 410 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS BUILD_HOST CONFIG_SITE
pankso@1 411 local LC_ALL=POSIX LANG=POSIX
pankso@1 412
pankso@126 413 # Check for build deps and handle implicit depends of *-dev packages
pankso@126 414 # (ex: libusb-dev :: libusb).
pankso@1 415 cd $INSTALLED && ls -1 > $CACHE/installed.list
pankso@1 416 [ "$DEPENDS" ] && gettext -e "Checking build dependencies...\n"
pankso@1 417 for dep in $BUILD_DEPENDS
pankso@1 418 do
pankso@126 419 implicit=${dep%-dev}
pankso@131 420 for i in $dep $implicit
pankso@126 421 do
pankso@131 422 if [ ! -f "$INSTALLED/$i/receipt" ]; then
pankso@126 423 # Try local package first.
pankso@131 424 vers=$(grep ^VERSION $WOK/$i/receipt | cut -d '"' -f 2)
pankso@131 425 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
pankso@131 426 gettext "Installing dep (pkg/local):"; echo " $i"
pankso@131 427 cd $PKGS && tazpkg install $i-$vers.tazpkg >/dev/null
pankso@126 428 else
pankso@131 429 gettext "Installing dep (web/cache):"; echo " $i"
pankso@131 430 tazpkg get-install $i >/dev/null
pankso@126 431 fi
pankso@1 432 fi
pankso@126 433 done
pankso@1 434 done
pankso@128 435 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
pankso@8 436
paul@62 437 # If a cook failed deps are not removed since we exit 1.
pankso@113 438 [ ! -s "installed.cook.diff" ] && \
pankso@141 439 busybox diff installed.list installed.cook > installed.cook.diff
pankso@113 440 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@1 441
pankso@1 442 # Get source tarball and make sure we have source dir named:
paul@62 443 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
paul@62 444 # tarball if it exists.
pankso@1 445 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
pankso@1 446 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
pankso@10 447 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
pankso@1 448 else
pankso@1 449 get_source || exit 1
pankso@1 450 fi
pankso@1 451 fi
pankso@9 452 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
pankso@1 453 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
pankso@1 454 extract_source || exit 1
paul@62 455 # Some archives are not well done and don't extract to one dir (ex lzma).
pankso@57 456 files=$(ls | wc -l)
pankso@57 457 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
pankso@57 458 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
pankso@57 459 mv * ../$PACKAGE-$VERSION
pankso@1 460 cd .. && rm -rf tmp
pankso@1 461 fi
pankso@1 462
pankso@9 463 # Execute receipt rules.
pankso@44 464 if grep -q ^compile_rules $receipt; then
pankso@1 465 gettext -e "Executing: compile_rules\n"
pankso@55 466 [ -d "$src" ] && cd $src
pankso@97 467 compile_rules $@ || exit 1
pankso@10 468 # Stay compatible with _pkg
pankso@55 469 [ -d "$src/_pkg" ] && mv $src/_pkg $install
pankso@9 470 # QA: compile_rules success so valid.
pankso@9 471 mkdir -p $install
pankso@9 472 else
pankso@9 473 # QA: No compile_rules so no error, valid.
pankso@9 474 mkdir -p $install
pankso@1 475 fi
pankso@1 476 separator && echo ""
pankso@1 477 }
pankso@1 478
pankso@1 479 # Cook quality assurance.
pankso@1 480 cookit_quality() {
pankso@9 481 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
pankso@15 482 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
pankso@9 483 fi
pankso@9 484 # ERROR can be echoed any time in cookit()
pankso@33 485 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@17 486 debug_info | tee -a $LOGS/$pkg.log
pankso@33 487 rm -f $command && exit 1
pankso@1 488 fi
pankso@1 489 }
pankso@1 490
pankso@16 491 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
paul@62 492 # but it doesn't handle EXTRAVERSION.
pankso@1 493 packit() {
pankso@1 494 set_paths
pankso@55 495 echo "Pack: $PACKAGE $VERSION"
pankso@1 496 separator
pankso@44 497 if grep -q ^genpkg_rules $receipt; then
pankso@16 498 gettext -e "Executing: genpkg_rules\n"
pankso@16 499 cd $pkgdir
pankso@98 500 mkdir -p $fs && genpkg_rules || echo -e \
pankso@98 501 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
pankso@16 502 fi
pankso@98 503
pankso@98 504 # First QA check to stop now if genpkg_rules failed.
pankso@98 505 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@98 506 exit 1
pankso@98 507 fi
pankso@98 508
pankso@44 509 cd $taz
pankso@1 510 for file in receipt description.txt
pankso@1 511 do
pankso@1 512 [ ! -f "../$file" ] && continue
pankso@1 513 gettext "Copying"; echo -n " $file..."
pankso@1 514 cp -f ../$file $pack && chown 0.0 $pack/$file && status
pankso@1 515 done
pankso@119 516 copy_generic_files
pankso@16 517
paul@62 518 # Create files.list with redirecting find output.
pankso@16 519 gettext "Creating the list of files..." && cd $fs
pankso@16 520 find . -type f -print > ../files.list
pankso@16 521 find . -type l -print >> ../files.list
pankso@16 522 cd .. && sed -i s/'^.'/''/ files.list
pankso@16 523 status
pankso@43 524
pankso@119 525 # Strip and stuff files.
pankso@43 526 strip_package
pankso@43 527
pankso@43 528 # Md5sum of files.
pankso@16 529 gettext "Creating md5sum of files..."
pankso@16 530 while read file; do
pankso@16 531 [ -L "fs$file" ] && continue
pankso@16 532 [ -f "fs$file" ] || continue
pankso@16 533 case "$file" in
pankso@16 534 /lib/modules/*/modules.*|*.pyc) continue;;
pankso@16 535 esac
pankso@16 536 md5sum "fs$file" | sed 's/ fs/ /'
pankso@16 537 done < files.list > md5sum
pankso@16 538 status
pankso@16 539 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
pankso@16 540 description.txt 2> /dev/null | awk \
pankso@16 541 '{ sz=$1 } END { print sz }')
pankso@16 542
pankso@16 543 # Build cpio archives.
pankso@16 544 gettext "Compressing the fs... "
pankso@16 545 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
pankso@16 546 rm -rf fs
pankso@16 547 status
pankso@16 548 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
pankso@16 549 md5sum description.txt 2> /dev/null | awk \
pankso@16 550 '{ sz=$1 } END { print sz }')
pankso@16 551 gettext "Updating receipt sizes..."
pankso@16 552 sed -i s/^PACKED_SIZE.*$// receipt
pankso@16 553 sed -i s/^UNPACKED_SIZE.*$// receipt
pankso@16 554 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
pankso@16 555 status
pankso@16 556
pankso@16 557 # Set extra version.
pankso@16 558 if [ "$EXTRAVERSION" ]; then
pankso@16 559 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
pankso@16 560 sed -i s/^EXTRAVERSION.*$// receipt
pankso@16 561 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
pankso@16 562 status
pankso@16 563 fi
pankso@16 564
pankso@16 565 # Compress.
pankso@16 566 gettext "Creating full cpio archive... "
pankso@16 567 find . -print | cpio -o -H newc --quiet > \
pankso@16 568 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
pankso@16 569 status
pankso@16 570 gettext "Restoring original package tree... "
pankso@16 571 unlzma -c fs.cpio.lzma | cpio -idm --quiet
pankso@16 572 status
pankso@16 573 rm fs.cpio.lzma && cd ..
pankso@43 574
pankso@43 575 # QA and give info.
pankso@43 576 tazpkg=$(ls *.tazpkg)
pankso@43 577 packit_quality
pankso@43 578 separator && gettext "Package:"; echo -e " $tazpkg\n"
pankso@1 579 }
pankso@1 580
paul@62 581 # Verify package quality and consistency.
pankso@8 582 packit_quality() {
pankso@142 583 gettext "QA: Checking for broken link..."
pankso@143 584 link=$(find $taz -type l -follow)
pankso@143 585 [ "$link" ] && echo -e "\nERROR: broken link in filesystem"
pankso@143 586 status
pankso@142 587
pankso@142 588 # Exit if any error found in log file.
pankso@33 589 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@32 590 rm -f $command && exit 1
pankso@8 591 fi
pankso@142 592
pankso@44 593 gettext "QA: Checking for empty package..."
pankso@45 594 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
pankso@45 595 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
pankso@44 596 echo -e "\nERROR: empty package"
pankso@32 597 rm -f $command && exit 1
pankso@8 598 else
pankso@134 599 # Ls sort by name so the first file is the one we want.
pankso@136 600 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
pankso@134 601 status
pankso@135 602 [ "$old" ] && echo -n "Removing old: $(basename $old)" && \
pankso@135 603 rm -f $old && status
pankso@134 604 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
pankso@11 605 sed -i /^${pkg}$/d $broken
pankso@8 606 fi
pankso@8 607 }
pankso@8 608
pankso@1 609 #
pankso@1 610 # Commands
pankso@1 611 #
pankso@1 612
pankso@1 613 case "$1" in
pankso@32 614 usage|help|-u|-h)
pankso@1 615 usage ;;
pankso@1 616 list-wok)
pankso@52 617 gettext -e "\nList of packages in:"; echo " $WOK"
pankso@1 618 separator
pankso@1 619 cd $WOK && ls -1
pankso@1 620 separator
pankso@1 621 echo -n "Packages: " && ls | wc -l
pankso@1 622 echo "" ;;
pankso@69 623 search)
pankso@69 624 # Just a simple search function, we dont need more actually.
pankso@69 625 query="$2"
pankso@69 626 gettext -e "\nSearch results for:"; echo " $query"
pankso@69 627 separator
pankso@69 628 cd $WOK && ls -1 | grep "$query"
pankso@69 629 separator && echo "" ;;
pankso@1 630 setup)
pankso@1 631 # Setup a build environment
pankso@1 632 check_root
pankso@11 633 echo "Cook: setting up the environment" | log
pankso@1 634 gettext -e "\nSetting up your environment\n"
pankso@1 635 separator && cd $SLITAZ
pankso@52 636 init_db_files
pankso@1 637 gettext -e "Checking for packages to install...\n"
pankso@29 638 for pkg in $SETUP_PKGS
pankso@1 639 do
pankso@52 640 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
pankso@1 641 done
pankso@1 642
pankso@1 643 # Handle --options
pankso@1 644 case "$2" in
pankso@49 645 --wok|-w)
pankso@52 646 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
pankso@52 647 tazpkg get-install mercurial
paul@62 648 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
pankso@1 649 hg clone $HG_URL ;;
pankso@1 650 esac
pankso@1 651
pankso@1 652 # SliTaz group and permissions
pankso@1 653 if ! grep -q ^slitaz /etc/group; then
pankso@1 654 gettext -e "Adding group: slitaz\n"
pankso@1 655 addgroup slitaz
pankso@1 656 fi
pankso@1 657 gettext -e "Setting permissions for slitaz group...\n"
pankso@1 658 chown -R root.slitaz $SLITAZ
pankso@1 659 chmod -R g+w $SLITAZ
pankso@1 660 separator
pankso@1 661 gettext -e "All done, ready to cook packages :-)\n\n" ;;
pankso@9 662 test)
pankso@9 663 # Test a cook environment.
pankso@13 664 echo "Cook test: testing the cook environment" | log
pankso@9 665 [ ! -d "$WOK" ] && exit 1
pankso@9 666 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
pankso@9 667 cook cooktest ;;
pankso@1 668 new)
pankso@1 669 # Create the package folder and an empty receipt.
pankso@1 670 pkg="$2"
pankso@1 671 [ "$pkg" ] || usage
pankso@60 672 [ -d "${WOK}-hg" ] && WOK=${WOK}-hg
pankso@1 673 echo ""
pankso@1 674 if [ -d "$WOK/$pkg" ]; then
paul@62 675 echo -n "$pkg " && gettext "package already exists."
pankso@1 676 echo -e "\n" && exit 1
pankso@1 677 fi
pankso@1 678 gettext "Creating"; echo -n " $WOK/$pkg"
pankso@1 679 mkdir $WOK/$pkg && cd $WOK/$pkg && status
pankso@1 680 gettext "Preparing the package receipt..."
pankso@1 681 cp $DATA/receipt .
pankso@1 682 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
pankso@1 683 status && echo "" ;;
pankso@1 684 list)
pankso@1 685 # Cook a list of packages (better use the Cooker since it will order
pankso@1 686 # packages before executing cook).
pankso@1 687 check_root
pankso@1 688 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
pankso@1 689 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
pankso@1 690 echo -e " $2\n" && exit 1
pankso@13 691 echo "Cook list starting: $2" | log
pankso@1 692 for pkg in $(cat $2)
pankso@1 693 do
pankso@1 694 cook $pkg || broken
pankso@1 695 done ;;
pankso@1 696 clean-wok)
pankso@1 697 check_root
pankso@1 698 gettext -e "\nCleaning all packages files..."
pankso@1 699 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
pankso@1 700 status && echo "" ;;
pankso@1 701 clean-src)
pankso@1 702 check_root
paul@62 703 gettext -e "\nCleaning all packages sources..."
pankso@1 704 rm -rf $WOK/*/source
pankso@1 705 status && echo "" ;;
pankso@1 706 pkglist)
paul@62 707 # Create suitable packages list for TazPKG and only for built packages.
pankso@1 708 [ "$2" ] && PKGS="$2"
pankso@1 709 [ ! -d "$PKGS" ] && \
paul@62 710 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
pankso@133 711 echo "cook:pkglist" > $command
paul@62 712 echo "Cook pkglist: Creating all packages lists" | log
pankso@1 713 gettext -e "\nCreating lists for:"; echo " $PKGS"
pankso@1 714 separator
pankso@133 715 cd $PKGS
pankso@1 716 rm -f packages.* files.list*
pankso@1 717 gettext -e "Creating: packages.list\n"
pankso@85 718 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
pankso@1 719 gettext -e "Creating: packages.md5\n"
pankso@1 720 md5sum *.tazpkg > $PKGS/packages.md5
pankso@1 721 gettext -e "Creating: packages.desc\n"
pankso@1 722 gettext -e "Creating: packages.equiv\n"
pankso@1 723 cd $WOK
pankso@1 724 for pkg in *
pankso@1 725 do
pankso@1 726 unset_receipt
pankso@1 727 . $pkg/receipt
pankso@1 728 # packages.desc let us search easily in DB
pankso@1 729 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 730 cat >> $PKGS/packages.desc << EOT
pankso@1 731 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
pankso@1 732 EOT
pankso@1 733 # Packages.equiv is used by tazpkg install to check depends.
pankso@1 734 for i in $PROVIDE; do
pankso@1 735 DEST=""
pankso@1 736 echo $i | fgrep -q : && DEST="${i#*:}:"
pankso@1 737 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
pankso@1 738 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
pankso@1 739 $PKGS/packages.equiv
pankso@1 740 else
pankso@1 741 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
pankso@1 742 fi
pankso@1 743 done
pankso@1 744 fi
pankso@1 745 done
pankso@1 746 # files.list.lzma
pankso@1 747 #lzma e files.list files.list.lzma
pankso@1 748 separator
pankso@1 749 nb=$(ls $PKGS/*.tazpkg | wc -l)
pankso@133 750 echo -e "Packages: $nb\n"
pankso@133 751 rm -f $command ;;
pankso@1 752 *)
pankso@1 753 # Just cook and generate a package.
pankso@1 754 check_root
pankso@1 755 time=$(date +%s)
pankso@1 756 pkg="$1"
pankso@1 757 [ -z "$pkg" ] && usage
pankso@44 758 receipt="$WOK/$pkg/receipt"
pankso@1 759 check_pkg_in_wok && echo ""
pankso@47 760
pankso@128 761 # Display and log info if cook process stopped.
pankso@128 762 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
pankso@128 763 tee -a $LOGS/$pkg.log' INT
pankso@128 764
pankso@47 765 # Skip blocked, 3 lines also for the Cooker.
pankso@51 766 if grep -q "^$pkg$" $blocked && [ "$2" != "--*" ]; then
pankso@47 767 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
pankso@47 768 fi
pankso@47 769
pankso@47 770 # Log and source receipt.
pankso@56 771 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
pankso@16 772 echo "cook:$pkg" > $command
pankso@1 773 unset inst
pankso@1 774 unset_receipt
pankso@44 775 . $receipt
pankso@1 776
pankso@1 777 # Handle --options
pankso@1 778 case "$2" in
pankso@1 779 --clean|-c)
pankso@49 780 gettext -e "Cleaning:"; echo -n " $pkg"
pankso@1 781 cd $WOK/$pkg && rm -rf install taz source
pankso@1 782 status && echo "" && exit 0 ;;
pankso@1 783 --install|-i)
pankso@1 784 inst='yes' ;;
pankso@49 785 --getsrc|-gs)
pankso@49 786 gettext "Getting source for:"; echo " $pkg"
pankso@45 787 separator && get_source
pankso@39 788 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
pankso@49 789 --block|-b)
pankso@49 790 gettext "Blocking:"; echo -n " $pkg"
pankso@49 791 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
pankso@49 792 status && echo "" && exit 0 ;;
pankso@49 793 --unblock|-ub)
pankso@49 794 gettext "Unblocking:"; echo -n " $pkg"
pankso@49 795 sed -i "/^${pkg}$/"d $blocked
pankso@49 796 status && echo "" && exit 0 ;;
pankso@1 797 esac
pankso@1 798
paul@62 799 # Check if wanted is built now so we have separate log files.
pankso@1 800 if [ "$WANTED" ] && [ ! -d "$WOK/$WANTED/install" ]; then
pankso@138 801 if ! grep -q "^$WANTED$" $broken; then
pankso@137 802 cook "$WANTED"
pankso@137 803 fi
pankso@1 804 fi
pankso@1 805
pankso@1 806 # Cook and pack or exit on error and log everything.
pankso@97 807 cookit $@ 2>&1 | tee $LOGS/$pkg.log
pankso@15 808 remove_deps | tee -a $LOGS/$pkg.log
pankso@1 809 cookit_quality
pankso@26 810 packit 2>&1 | tee -a $LOGS/$pkg.log
pankso@1 811 clean_log
pankso@33 812
pankso@33 813 # Exit if any error in packing.
pankso@33 814 if grep -q ^ERROR $LOGS/$pkg.log; then
pankso@33 815 debug_info | tee -a $LOGS/$pkg.log
pankso@33 816 rm -f $command && exit 1
pankso@33 817 fi
pankso@16 818
pankso@1 819 # Time and summary
pankso@1 820 time=$(($(date +%s) - $time))
pankso@1 821 summary | tee -a $LOGS/$pkg.log
pankso@50 822 echo ""
pankso@1 823
pankso@1 824 # Install package if requested
pankso@1 825 if [ "$inst" ]; then
pankso@1 826 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 827 cd $PKGS && tazpkg install \
pankso@1 828 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
pankso@1 829 else
paul@62 830 gettext -e "Unable to install package, build has failed.\n\n"
pankso@1 831 exit 1
pankso@1 832 fi
pankso@1 833 fi
pankso@9 834 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
pankso@17 835 # You want automation: use the Cooker Build Bot.
pankso@1 836 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
pankso@18 837 rm -f $command ;;
pankso@1 838 esac
pankso@1 839
pankso@1 840 exit 0